/*
 * IBM Confidential
 * OCO Source Materials
 * Rational ClearCase
 * (C) Copyright IBM Corporation. 2013.  All rights reserved.
 *
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */
package com.ibm.rational.wvcm.stp.cc;

import javax.wvcm.Feedback;
import javax.wvcm.Resource;
import javax.wvcm.ResourceList;
import javax.wvcm.WvcmException;

/**
 * <p>A proxy for a resource in a ClearCase VOB or view.
 * </p>
 */
public interface CcResourceList <T extends Resource>
    extends ResourceList<T> {

    /**
     * Variant of {@link ResourceList#doWriteProperties(Feedback)} that
     * supports supplying a context.  All other behavior is the same.
     * @param context An optional proxy (often CcView) providing context for the
     *            writing of certain properties. May be <b>null</b>.
     * @param feedback the properties available in the returned proxies.
     * @return an iterator over the results of the method on each element in this ResourceList.
     */
    public <V> ResponseIterator<V> doWriteProperties(Resource context, 
                                      Feedback feedback) throws WvcmException;

    
}
